libgimpprint API Reference: print-lexmark.c File Reference

Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals | Related Pages

# src/main/print-lexmark.c File Reference

`#include <gimp-print/gimp-print.h>`
`#include <gimp-print/gimp-print-intl-internal.h>`
`#include "gimp-print-internal.h"`
`#include <string.h>`

Go to the source code of this file.

## Data Structures
union | lexmark_lineoff_t
union | lexmark_linebufs_t
struct | float_param_t
struct | lexmark_res_t
struct | lexmark_inkparam_t
struct | lexmark_inkname_t
struct | lexmark_cap_t
struct | lexm_privdata_weave
struct | paper_t
struct | Lexmark_head_colors
## Defines
#define | USEEPSEWAVE 1
#define | STP_ECOLOR_LC 4
#define | STP_ECOLOR_LM 5
#define | STP_ECOLOR_LY 6
#define | false 0
#define | true 1
#define | max(a, b) ((a > b) ? (a) : (b))
#define | INCH(x) (72 * x)
#define | NCHANNELS (7)
#define | DPI300 0
#define | DPI600 1
#define | DPI1200 2
#define | DPI2400 3
#define | DPItest 4
#define | V_NOZZLE_MASK 0x3
#define | H_NOZZLE_MASK 0xc
#define | NOZZLE_MASK 0xf
#define | PRINT_MODE_300 0x100
#define | PRINT_MODE_600 0x200
#define | PRINT_MODE_1200 0x300
#define | PRINT_MODE_2400 0x400
#define | COLOR_MODE_K 0x1000
#define | COLOR_MODE_C 0x2000
#define | COLOR_MODE_Y 0x4000
#define | COLOR_MODE_M 0x8000
#define | COLOR_MODE_LC 0x10000
#define | COLOR_MODE_LY 0x20000
#define | COLOR_MODE_LM 0x40000
#define | COLOR_MODE_CMYK (COLOR_MODE_C | COLOR_MODE_M | COLOR_MODE_Y | COLOR_MODE_K)
#define | COLOR_MODE_CMY (COLOR_MODE_C | COLOR_MODE_M | COLOR_MODE_Y)
#define | COLOR_MODE_CcMcYK (COLOR_MODE_C | COLOR_MODE_LC | COLOR_MODE_M | COLOR_MODE_LM | COLOR_MODE_Y | COLOR_MODE_K)
#define | COLOR_MODE_CcMcY (COLOR_MODE_C | COLOR_MODE_LC | COLOR_MODE_M | COLOR_MODE_LM | COLOR_MODE_Y)
#define | COLOR_MODE_MASK 0x7f000
#define | PRINT_MODE_MASK 0xf00
#define | COLOR_MODE_PHOTO (COLOR_MODE_LC | COLOR_MODE_LM)
#define | BWR 0
#define | BWL 1
#define | CR 2
#define | CL 3
#define | LEXMARK_INK_K 1
#define | LEXMARK_INK_CMY 2
#define | LEXMARK_INK_CMYK 4
#define | LEXMARK_INK_CcMmYK 8
#define | LEXMARK_INK_CcMmYy 16
#define | LEXMARK_INK_CcMmYyK 32
#define | LEXMARK_INK_BLACK_MASK
#define | LEXMARK_INK_PHOTO_MASK
#define | LEXMARK_SLOT_ASF1 1
#define | LEXMARK_SLOT_ASF2 2
#define | LEXMARK_SLOT_MAN1 4
#define | LEXMARK_SLOT_MAN2 8
#define | LEXMARK_CAP_DMT 1<<0 /* Drop Modulation Technology */
#define | LEXMARK_CAP_MSB_FIRST 1<<1 /* how to send data */
#define | LEXMARK_CAP_CMD61 1<<2 /* uses command #0x61 */
#define | LEXMARK_CAP_CMD6d 1<<3 /* uses command #0x6d */
#define | LEXMARK_CAP_CMD70 1<<4 /* uses command #0x70 */
#define | LEXMARK_CAP_CMD72 1<<5 /* uses command #0x72 */
#define | LEXM_RES_COUNT 30
#define | LX_Z52_300_DPI 1
#define | LX_Z52_600_DPI 3
#define | LX_Z52_1200_DPI 4
#define | LX_Z52_2400_DPI 5
#define | LX_Z52_COLOR_PRINT 0
#define | LX_Z52_BLACK_PRINT 1
#define | LX_PSHIFT 0x13
#define | LX_Z52_COLOR_MODE_POS 0x9
#define | LX_Z52_RESOLUTION_POS 0x7
#define | LX_Z52_PRINT_DIRECTION_POS 0x8
#define | LXM_Z52_HEADERSIZE 34
#define | LXM_Z42_HEADERSIZE 34
#define | LXM3200_LEFTOFFS 6254
#define | LXM3200_RIGHTOFFS (LXM3200_LEFTOFFS-2120)
#define | LXM_3200_HEADERSIZE 24
#define | LXM_Z52_STARTSIZE 0x35
#define | LXM_Z42_STARTSIZE 0x30
#define | ESC2a "\033\052"
#define | LXM_3200_STARTSIZE 32
#define | stp_module_version print_lexmark_LTX_stp_module_version
#define | stp_module_data print_lexmark_LTX_stp_module_data
## Typedefs
typedef enum Lex_model | Lex_model
typedef lexmark_res_t | lexmark_res_t_array [LEXM_RES_COUNT]
typedef lexm_privdata_weave | lexm_privdata_weave
typedef Lexmark_head_colors | Lexmark_head_colors
## Enumerations
enum | Lex_model { m_lex7500, m_z52 = 10052, m_z42 = 10042, m_3200 = 3200 }
## Functions
void | flush_pass (stp_vars_t *v, int passno, int vertical_subpass)
int | get_lr_shift (int mode)
int | lexmark_calc_3200_checksum (unsigned char *data)
int | model_to_index (int model)
const lexmark_cap_t * | lexmark_get_model_capabilities (int model)
const lexmark_inkname_t * | lexmark_get_ink_type (const char *name, int printing_color, const lexmark_cap_t *caps)
const lexmark_inkparam_t * | lexmark_get_ink_parameter (const char *name, int printing_color, const lexmark_cap_t *caps, const stp_vars_t *nv)
const paper_t * | get_media_type (const char *name, const lexmark_cap_t *caps)
int | lexmark_source_type (const char *name, const lexmark_cap_t *caps)
const lexmark_lineoff_t * | lexmark_head_offset (int ydpi, const char *ink_type, const lexmark_cap_t *caps, const lexmark_inkparam_t *ink_parameter, lexmark_lineoff_t *lineoff_buffer)
int | lexmark_get_phys_resolution_vertical (int model)
const lexmark_res_t * | lexmark_get_resolution_para (int model, const char *resolution)
int | lexmark_print_bidirectional (int model, const char *resolution)
const char * | lexmark_lum_adjustment (const lexmark_cap_t *caps, const stp_vars_t *v)
const char * | lexmark_hue_adjustment (const lexmark_cap_t *caps, const stp_vars_t *v)
const char * | lexmark_sat_adjustment (const lexmark_cap_t *caps, const stp_vars_t *v)
void | lexmark_describe_resolution (const stp_vars_t *v, int *x, int *y)
stp_parameter_list_t | lexmark_list_parameters (const stp_vars_t *v)
const char * | lexmark_describe_output (const stp_vars_t *v)
void | lexmark_parameters (const stp_vars_t *v, const char *name, stp_parameter_t *description)
void | internal_imageable_area (const stp_vars_t *v, int use_paper_margins, int *left, int *right, int *bottom, int *top)
void | lexmark_imageable_area (const stp_vars_t *v, int *left, int *right, int *bottom, int *top)
void | lexmark_limit (const stp_vars_t *v, int *width, int *height, int *min_width, int *min_height)
int | lexmark_init_printer (const stp_vars_t *v, const lexmark_cap_t *caps, int printing_color, const char *source_str, int xdpi, int ydpi, int page_width, int page_height, int top, int left, int use_dmt)
void | lexmark_deinit_printer (const stp_vars_t *v, const lexmark_cap_t *caps)
void | paper_shift (const stp_vars_t *v, int offset, const lexmark_cap_t *caps)
double | get_double_param (stp_vars_t *v, const char *param)
int | lexmark_do_print (stp_vars_t *v, stp_image_t *image)
int | lexmark_print (const stp_vars_t *v, stp_image_t *image)
unsigned char * | lexmark_init_line (int mode, unsigned char *prnBuf, int pass_length, int offset, int width, int direction, const lexmark_inkparam_t *ink_parameter, const lexmark_cap_t *caps)
int | lexmark_write (const stp_vars_t *v, unsigned char *prnBuf, int *paperShift, int direction, int pass_length, const lexmark_cap_t *caps, const lexmark_inkparam_t *ink_parameter, int xdpi, int yCount, Lexmark_head_colors *head_colors, int length, int mode, int ydpi, int width, int offset, int dmt)
int | print_lexmark_module_init (void)
int | print_lexmark_module_exit (void)
## Variables
const stp_dotsize_t | single_dotsize []
const stp_shade_t | photo_dither_shades []
const char | standard_sat_adjustment []
const char | standard_lum_adjustment []
const char | standard_hue_adjustment []
const int | lr_shift_color [10] = { 9, 18, 2*18 }
const int | lr_shift_black [10] = { 9, 18, 2*18 }
const stp_parameter_t | the_parameters []
const int | the_parameter_count
const float_param_t | float_parameters []
const int | float_parameter_count
const int | head_offset_cmyk []
const int | head_offset_cmy []
const int | head_offset_cCmMyk []
const int | IDX_SEQLEN = 3
const unsigned char | outbufHeader_z52 [LXM_Z52_HEADERSIZE]
const unsigned char | outbufHeader_z42 [LXM_Z42_HEADERSIZE]
const lexmark_res_t_array | lexmark_reslist_z52
const lexmark_inkname_t | ink_types_z52 []
int | lxm3200_headpos = 0
int | lxm3200_linetoeject = 0
const char | outbufHeader_3200 [LXM_3200_HEADERSIZE]
const lexmark_res_t_array | lexmark_reslist_3200
const lexmark_inkname_t | ink_types_3200 []
const lexmark_cap_t | lexmark_model_capabilities []
const paper_t | lexmark_paper_list []
const int | paper_type_count = sizeof(lexmark_paper_list) / sizeof(paper_t)
stp_param_string_t | media_sources []
const stp_printfuncs_t | print_lexmark_printfuncs
stp_family_t | print_lexmark_module_data
stp_module_version_t | stp_module_version = {0, 0}
stp_module_t | stp_module_data

## Define Documentation

#define BWL 1

| Definition at line 175 of file print-lexmark.c.

#define BWR 0

| Definition at line 174 of file print-lexmark.c.

#define CL 3

| Definition at line 177 of file print-lexmark.c.

#define COLOR_MODE_C 0x2000

| Definition at line 159 of file print-lexmark.c.

#define COLOR_MODE_CcMcY (COLOR_MODE_C | COLOR_MODE_LC | COLOR_MODE_M | COLOR_MODE_LM | COLOR_MODE_Y)

| Definition at line 168 of file print-lexmark.c.

#define COLOR_MODE_CcMcYK (COLOR_MODE_C | COLOR_MODE_LC | COLOR_MODE_M | COLOR_MODE_LM | COLOR_MODE_Y | COLOR_MODE_K)

| Definition at line 167 of file print-lexmark.c.

#define COLOR_MODE_CMY (COLOR_MODE_C | COLOR_MODE_M | COLOR_MODE_Y)

| Definition at line 166 of file print-lexmark.c.

#define COLOR_MODE_CMYK (COLOR_MODE_C | COLOR_MODE_M | COLOR_MODE_Y | COLOR_MODE_K)

| Definition at line 165 of file print-lexmark.c.

#define COLOR_MODE_K 0x1000

| Definition at line 158 of file print-lexmark.c. Referenced by get_lr_shift(), lexmark_describe_output(), and lexmark_init_line().

#define COLOR_MODE_LC 0x10000

| Definition at line 162 of file print-lexmark.c. Referenced by lexmark_init_line().

#define COLOR_MODE_LM 0x40000

| Definition at line 164 of file print-lexmark.c. Referenced by lexmark_init_line().

#define COLOR_MODE_LY 0x20000

| Definition at line 163 of file print-lexmark.c.

#define COLOR_MODE_M 0x8000

| Definition at line 161 of file print-lexmark.c.

#define COLOR_MODE_MASK 0x7f000

| Definition at line 170 of file print-lexmark.c. Referenced by get_lr_shift().

#define COLOR_MODE_PHOTO (COLOR_MODE_LC | COLOR_MODE_LM)

| Definition at line 172 of file print-lexmark.c.

#define COLOR_MODE_Y 0x4000

| Definition at line 160 of file print-lexmark.c.

#define CR 2

| Definition at line 176 of file print-lexmark.c.

#define DPI1200 2

| Definition at line 145 of file print-lexmark.c.

#define DPI2400 3

| Definition at line 146 of file print-lexmark.c.

#define DPI300 0

| Definition at line 143 of file print-lexmark.c.

#define DPI600 1

| Definition at line 144 of file print-lexmark.c.

#define DPItest 4

| Definition at line 147 of file print-lexmark.c.

#define ESC2a "\033\052"

#define false 0

| Definition at line 72 of file print-lexmark.c.

#define H_NOZZLE_MASK 0xc

| Definition at line 150 of file print-lexmark.c.

#define INCH | ( | x |  | ) | (72 * x)

| Definition at line 76 of file print-lexmark.c.

#define LEXM_RES_COUNT 30

| Definition at line 466 of file print-lexmark.c.

#define LEXMARK_CAP_CMD61 1<<2 /* uses command #0x61 */

| Definition at line 255 of file print-lexmark.c.

#define LEXMARK_CAP_CMD6d 1<<3 /* uses command #0x6d */

| Definition at line 257 of file print-lexmark.c.

#define LEXMARK_CAP_CMD70 1<<4 /* uses command #0x70 */

| Definition at line 259 of file print-lexmark.c.

#define LEXMARK_CAP_CMD72 1<<5 /* uses command #0x72 */

| Definition at line 261 of file print-lexmark.c.

#define LEXMARK_CAP_DMT 1<<0 /* Drop Modulation Technology */

| Definition at line 251 of file print-lexmark.c.

#define LEXMARK_CAP_MSB_FIRST 1<<1 /* how to send data */

| Definition at line 253 of file print-lexmark.c.

#define LEXMARK_INK_BLACK_MASK

| Value:
    (LEXMARK_INK_K|LEXMARK_INK_CMYK|\
                                  LEXMARK_INK_CcMmYK|LEXMARK_INK_CcMmYyK)
Definition at line 238 of file print-lexmark.c.

#define LEXMARK_INK_CcMmYK 8

| Definition at line 234 of file print-lexmark.c.

#define LEXMARK_INK_CcMmYy 16

| Definition at line 235 of file print-lexmark.c.

#define LEXMARK_INK_CcMmYyK 32

| Definition at line 236 of file print-lexmark.c.

#define LEXMARK_INK_CMY 2

| Definition at line 232 of file print-lexmark.c.

#define LEXMARK_INK_CMYK 4

| Definition at line 233 of file print-lexmark.c.

#define LEXMARK_INK_K 1

| Definition at line 231 of file print-lexmark.c. Referenced by lexmark_describe_output().

#define LEXMARK_INK_PHOTO_MASK

| Value:
    (LEXMARK_INK_CcMmYy|LEXMARK_INK_CcMmYK|\
                                  LEXMARK_INK_CcMmYyK)
Definition at line 241 of file print-lexmark.c.

#define LEXMARK_SLOT_ASF1 1

| Definition at line 245 of file print-lexmark.c.

#define LEXMARK_SLOT_ASF2 2

| Definition at line 246 of file print-lexmark.c.

#define LEXMARK_SLOT_MAN1 4

| Definition at line 247 of file print-lexmark.c.

#define LEXMARK_SLOT_MAN2 8

| Definition at line 248 of file print-lexmark.c.

#define LX_PSHIFT 0x13

| Definition at line 534 of file print-lexmark.c.

#define LX_Z52_1200_DPI 4

| Definition at line 528 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_2400_DPI 5

| Definition at line 529 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_300_DPI 1

| Definition at line 526 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_600_DPI 3

| Definition at line 527 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_BLACK_PRINT 1

| Definition at line 532 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_COLOR_MODE_POS 0x9

| Definition at line 535 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_COLOR_PRINT 0

| Definition at line 531 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_PRINT_DIRECTION_POS 0x8

| Definition at line 537 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LX_Z52_RESOLUTION_POS 0x7

| Definition at line 536 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LXM3200_LEFTOFFS 6254

| Definition at line 629 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LXM3200_RIGHTOFFS (LXM3200_LEFTOFFS-2120)

| Definition at line 630 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LXM_3200_HEADERSIZE 24

| Definition at line 635 of file print-lexmark.c. Referenced by lexmark_init_line(), and lexmark_write().

#define LXM_3200_STARTSIZE 32

| Referenced by lexmark_init_printer().

#define LXM_Z42_HEADERSIZE 34

| Definition at line 568 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LXM_Z42_STARTSIZE 0x30

| Referenced by lexmark_init_printer().

#define LXM_Z52_HEADERSIZE 34

| Definition at line 555 of file print-lexmark.c. Referenced by lexmark_init_line().

#define LXM_Z52_STARTSIZE 0x35

| Referenced by lexmark_init_printer().

#define max | ( | a,
|  | b |  | ) | ((a > b) ? (a) : (b))

| Definition at line 75 of file print-lexmark.c. Referenced by calc_rgb_to_hsl(), and internal_imageable_area().

#define NCHANNELS (7)

| Definition at line 92 of file print-lexmark.c.

#define NOZZLE_MASK 0xf

| Definition at line 151 of file print-lexmark.c.

#define PRINT_MODE_1200 0x300

| Definition at line 155 of file print-lexmark.c. Referenced by lexmark_init_line().

#define PRINT_MODE_2400 0x400

| Definition at line 156 of file print-lexmark.c. Referenced by lexmark_init_line().

#define PRINT_MODE_300 0x100

| Definition at line 153 of file print-lexmark.c. Referenced by lexmark_init_line().

#define PRINT_MODE_600 0x200

| Definition at line 154 of file print-lexmark.c. Referenced by lexmark_init_line().

#define PRINT_MODE_MASK 0xf00

| Definition at line 171 of file print-lexmark.c. Referenced by lexmark_init_line().

#define STP_ECOLOR_LC 4

| Definition at line 68 of file print-lexmark.c.

#define STP_ECOLOR_LM 5

| Definition at line 69 of file print-lexmark.c.

#define STP_ECOLOR_LY 6

| Definition at line 70 of file print-lexmark.c.

#define stp_module_data print_lexmark_LTX_stp_module_data

| Definition at line 3086 of file print-lexmark.c.

#define stp_module_version print_lexmark_LTX_stp_module_version

| Definition at line 3085 of file print-lexmark.c.

#define true 1

| Definition at line 73 of file print-lexmark.c.

#define USEEPSEWAVE 1

| Definition at line 51 of file print-lexmark.c.

#define V_NOZZLE_MASK 0x3

| Definition at line 149 of file print-lexmark.c.

## Typedef Documentation

typedef enum Lex_model Lex_model

typedef struct lexm_privdata_weave lexm_privdata_weave

typedef struct Lexmark_head_colors Lexmark_head_colors

typedef lexmark_res_t lexmark_res_t_array[LEXM_RES_COUNT]

| Definition at line 467 of file print-lexmark.c.

## Enumeration Type Documentation

enum Lex_model

  | Enumeration values:
  m_lex7500 |
  m_z52 |
  m_z42 |
  m_3200 |
Definition at line 90 of file print-lexmark.c.

## Function Documentation

void flush_pass | ( | stp_vars_t * | v,
|  | int | passno,
|  | int | vertical_subpass
| ) | `[static]`

| Definition at line 2725 of file print-lexmark.c.

double get_double_param | ( | stp_vars_t * | v,
|  | const char * | param
| ) | `[static]`

| Definition at line 1574 of file print-lexmark.c.

int get_lr_shift | ( | int | mode | ) | `[static]`

| Definition at line 382 of file print-lexmark.c. References COLOR_MODE_K, COLOR_MODE_MASK, and lr_shift_black. Referenced by lexmark_write().

const paper_t* get_media_type | ( | const char * | name,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 945 of file print-lexmark.c. References lexmark_paper_list. Referenced by get_default_inktype(), get_media_adjustment(), setup_misc(), and verify_resolution_by_paper_type().

void internal_imageable_area | ( | const stp_vars_t * | v,
|  | int | use_paper_margins,
|  | int * | left,
|  | int * | right,
|  | int * | bottom,
|  | int * | top
| ) | `[static]`

| Definition at line 1301 of file print-lexmark.c. References lexmark_cap_t::border_bottom, lexmark_cap_t::border_left, lexmark_cap_t::border_right, lexmark_cap_t::border_top, stp_papersize_t::bottom, stp_papersize_t::left, lexmark_get_model_capabilities(), max, stp_papersize_t::right, stp_default_media_size(), stp_get_model_id(), stp_get_papersize_by_name(), stp_get_string_parameter(), and stp_papersize_t::top.

int lexmark_calc_3200_checksum | ( | unsigned char * | data | ) | `[inline, static]`

| Definition at line 644 of file print-lexmark.c. Referenced by lexmark_init_line(), and lexmark_write().

void lexmark_deinit_printer | ( | const stp_vars_t * | v,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 1451 of file print-lexmark.c.

const char* lexmark_describe_output | ( | const stp_vars_t * | v | ) | `[static]`

| Definition at line 1146 of file print-lexmark.c. References COLOR_MODE_K, and LEXMARK_INK_K.

void lexmark_describe_resolution | ( | const stp_vars_t * | v,
|  | int * | x,
|  | int * | y
| ) | `[static]`

| Definition at line 1104 of file print-lexmark.c. References lexmark_res_t::hres, and lexmark_res_t::vres.

int lexmark_do_print | ( | stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 1593 of file print-lexmark.c. References stp_curve_t.

const lexmark_inkparam_t* lexmark_get_ink_parameter | ( | const char * | name,
|  | int | printing_color,
|  | const lexmark_cap_t * | caps,
|  | const stp_vars_t * | nv
| ) | `[static]`

| Definition at line 932 of file print-lexmark.c.

const lexmark_inkname_t* lexmark_get_ink_type | ( | const char * | name,
|  | int | printing_color,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 919 of file print-lexmark.c.

const lexmark_cap_t* lexmark_get_model_capabilities | ( | int | model | ) | `[static]`

| Definition at line 818 of file print-lexmark.c. Referenced by internal_imageable_area().

int lexmark_get_phys_resolution_vertical | ( | int | model | ) | `[static]`

| Definition at line 1040 of file print-lexmark.c.

const lexmark_res_t* lexmark_get_resolution_para | ( | int | model,
|  | const char * | resolution
| ) | `[static]`

| Definition at line 1053 of file print-lexmark.c. References lexmark_res_t::hres, lexmark_cap_t::max_xdpi, lexmark_cap_t::max_ydpi, lexmark_res_t::name, and lexmark_res_t::vres. Referenced by lexmark_sat_adjustment().

const lexmark_lineoff_t* lexmark_head_offset | ( | int | ydpi,
|  | const char * | ink_type,
|  | const lexmark_cap_t * | caps,
|  | const lexmark_inkparam_t * | ink_parameter,
|  | lexmark_lineoff_t * | lineoff_buffer
| ) | `[static]`

| Definition at line 981 of file print-lexmark.c.

const char* lexmark_hue_adjustment | ( | const lexmark_cap_t * | caps,
|  | const stp_vars_t * | v
| ) | `[static]`

| Definition at line 1091 of file print-lexmark.c. References lexmark_cap_t::sat_adjustment, and stp_vars_t.

void lexmark_imageable_area | ( | const stp_vars_t * | v,
|  | int * | left,
|  | int * | right,
|  | int * | bottom,
|  | int * | top
| ) | `[static]`

| Definition at line 1342 of file print-lexmark.c.

unsigned char* lexmark_init_line | ( | int | mode,
|  | unsigned char * | prnBuf,
|  | int | pass_length,
|  | int | offset,
|  | int | width,
|  | int | direction,
|  | const lexmark_inkparam_t * | ink_parameter,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 2217 of file print-lexmark.c. References COLOR_MODE_K, COLOR_MODE_LC, COLOR_MODE_LM, lexmark_inkparam_t::h_catridge_offset, lexmark_inkparam_t::h_direction_offset, lexmark_calc_3200_checksum(), LX_Z52_1200_DPI, LX_Z52_2400_DPI, LX_Z52_300_DPI, LX_Z52_600_DPI, LX_Z52_BLACK_PRINT, LX_Z52_COLOR_MODE_POS, LX_Z52_COLOR_PRINT, LX_Z52_PRINT_DIRECTION_POS, LX_Z52_RESOLUTION_POS, lxm3200_headpos, LXM3200_LEFTOFFS, LXM3200_RIGHTOFFS, LXM_3200_HEADERSIZE, LXM_Z42_HEADERSIZE, LXM_Z52_HEADERSIZE, m_3200, m_lex7500, m_z42, m_z52, lexmark_cap_t::model, outbufHeader_3200, outbufHeader_z42, outbufHeader_z52, PRINT_MODE_1200, PRINT_MODE_2400, PRINT_MODE_300, PRINT_MODE_600, PRINT_MODE_MASK, and stp_erprintf(). Referenced by lexmark_write().

int lexmark_init_printer | ( | const stp_vars_t * | v,
|  | const lexmark_cap_t * | caps,
|  | int | printing_color,
|  | const char * | source_str,
|  | int | xdpi,
|  | int | ydpi,
|  | int | page_width,
|  | int | page_height,
|  | int | top,
|  | int | left,
|  | int | use_dmt
| ) | `[static]`

| Definition at line 1368 of file print-lexmark.c. References LXM_3200_STARTSIZE, LXM_Z42_STARTSIZE, LXM_Z52_STARTSIZE, m_3200, m_z42, m_z52, lexmark_cap_t::model, stp_erprintf(), and stp_zfwrite().

void lexmark_limit | ( | const stp_vars_t * | v,
|  | int * | width,
|  | int * | height,
|  | int * | min_width,
|  | int * | min_height
| ) | `[static]`

| Definition at line 1352 of file print-lexmark.c.

stp_parameter_list_t lexmark_list_parameters | ( | const stp_vars_t * | v | ) | `[static]`

| Definition at line 1134 of file print-lexmark.c. References float_parameter_count.

const char* lexmark_lum_adjustment | ( | const lexmark_cap_t * | caps,
|  | const stp_vars_t * | v
| ) | `[static]`

| Definition at line 1085 of file print-lexmark.c. References lexmark_cap_t::hue_adjustment, and stp_vars_t.

void lexmark_parameters | ( | const stp_vars_t * | v,
|  | const char * | name,
|  | stp_parameter_t * | description
| ) | `[static]`

| Definition at line 1170 of file print-lexmark.c. References stp_parameter_t::bounds, stp_parameter_t::deflt, float_param_t::defval, float_parameter_count, float_parameters, float_param_t::max, float_param_t::min, stp_fill_parameter_settings(), and STP_PARAMETER_TYPE_INVALID.

int lexmark_print | ( | const stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 2182 of file print-lexmark.c.

int lexmark_print_bidirectional | ( | int | model,
|  | const char * | resolution
| ) | `[static]`

| Definition at line 1078 of file print-lexmark.c. References lexmark_cap_t::lum_adjustment, and stp_vars_t.

const char* lexmark_sat_adjustment | ( | const lexmark_cap_t * | caps,
|  | const stp_vars_t * | v
| ) | `[static]`

| Definition at line 1097 of file print-lexmark.c. References lexmark_get_resolution_para(), stp_get_model_id(), stp_get_string_parameter(), and stp_vars_t.

int lexmark_source_type | ( | const char * | name,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 960 of file print-lexmark.c.

int lexmark_write | ( | const stp_vars_t * | v,
|  | unsigned char * | prnBuf,
|  | int * | paperShift,
|  | int | direction,
|  | int | pass_length,
|  | const lexmark_cap_t * | caps,
|  | const lexmark_inkparam_t * | ink_parameter,
|  | int | xdpi,
|  | int | yCount,
|  | Lexmark_head_colors * | head_colors,
|  | int | length,
|  | int | mode,
|  | int | ydpi,
|  | int | width,
|  | int | offset,
|  | int | dmt
| ) | `[static]`

| Definition at line 2430 of file print-lexmark.c. References get_lr_shift(), Lexmark_head_colors::head_nozzle_start, IDX_SEQLEN, lexmark_calc_3200_checksum(), lexmark_init_line(), LXM_3200_HEADERSIZE, m_3200, m_lex7500, m_z42, m_z52, lexmark_cap_t::max_paper_width, lexmark_cap_t::model, paper_shift(), stp_erprintf(), stp_zfwrite(), and lexmark_cap_t::x_raster_res.

int model_to_index | ( | int | model | ) | `[static]`

| Definition at line 804 of file print-lexmark.c.

void paper_shift | ( | const stp_vars_t * | v,
|  | int | offset,
|  | const lexmark_cap_t * | caps
| ) | `[static]`

| Definition at line 1518 of file print-lexmark.c. Referenced by lexmark_write().

int print_lexmark_module_exit | ( | void |  | ) | `[static]`

| Definition at line 3078 of file print-lexmark.c. References stp_module_version_t.

int print_lexmark_module_init | ( | void |  | ) | `[static]`

| Definition at line 3071 of file print-lexmark.c. References print_lexmark_module_data, stp_family::printer_list, and stp_family_unregister().

## Variable Documentation

const int float_parameter_count`[static]`

| Initial value:
    sizeof(float_parameters) / sizeof(const float_param_t)
Definition at line 378 of file print-lexmark.c. Referenced by lexmark_list_parameters(), and lexmark_parameters().

const float_param_t float_parameters[]`[static]`

| Definition at line 326 of file print-lexmark.c. Referenced by lexmark_parameters().

const int head_offset_cCmMyk[]`[static]`

| Initial value:
    {0, 368, 184, 0, 368, 184, 0}
Definition at line 444 of file print-lexmark.c.

const int head_offset_cmy[]`[static]`

| Initial value:
    {0, 368, 184, 0, 368, 184, 0}
Definition at line 442 of file print-lexmark.c.

const int head_offset_cmyk[]`[static]`

| Initial value:
    {70, 368, 184, 0, 368, 184, 0}
Definition at line 439 of file print-lexmark.c.

const int IDX_SEQLEN = 3`[static]`

| Definition at line 540 of file print-lexmark.c. Referenced by lexmark_write().

const lexmark_inkname_t ink_types_3200[]`[static]`

| Initial value:
    {

      { "CMYK",     N_("Four Color Standard"),
        {{ 1, COLOR_MODE_K,        208,  20, 0, 12, head_offset_cmyk },
         { 4, COLOR_MODE_CMYK,   192/3,   0, 0, 12, head_offset_cmyk }}},
      { "RGB",      N_("Three Color Composite"),
        {{ 1, COLOR_MODE_K,        208,  20, 0, 12, head_offset_cmyk },
         { 4, COLOR_MODE_CMY,    192/3,   0, 0, 12, head_offset_cmy }}},
      { "PhotoCMYK", N_("Six Color Photo"),
        {{ 1, COLOR_MODE_K,      192/3,   0, 0, 12, head_offset_cCmMyk },
         { 6, COLOR_MODE_CcMcYK, 192/3,   0, 0, 12, head_offset_cCmMyk }}},
      { "PhotoCMY", N_("Five Color Photo Composite"),
        {{ 1, COLOR_MODE_K,        208,  20, 0, 12, head_offset_cCmMyk },
         { 5, COLOR_MODE_CcMcY,  192/3,   0, 0, 12, head_offset_cCmMyk }}},
      { NULL, NULL }
    }
Definition at line 670 of file print-lexmark.c.

const lexmark_inkname_t ink_types_z52[]`[static]`

| Initial value:
    {

      { "CMYK",     N_("Four Color Standard"),
        {{ 1, COLOR_MODE_K,        208, 324, 0, 10, head_offset_cmyk },
         { 4, COLOR_MODE_CMYK,   192/3,   0, 0, 10, head_offset_cmyk }}},
      { "RGB",      N_("Three Color Composite"),
        {{ 1, COLOR_MODE_K,        208, 324, 0, 10, head_offset_cmyk },
         { 4, COLOR_MODE_CMY,    192/3,   0, 0, 10, head_offset_cmy }}},
      { "PhotoCMYK", N_("Six Color Photo"),
        {{ 1, COLOR_MODE_K,      192/3,   0, 0, 10, head_offset_cCmMyk },
         { 6, COLOR_MODE_CcMcYK, 192/3,   0, 0, 10, head_offset_cCmMyk }}},
      { "PhotoCMY", N_("Five Color Photo Composite"),
        {{ 1, COLOR_MODE_K,        208, 324, 0, 10, head_offset_cCmMyk },
         { 5, COLOR_MODE_CcMcY,  192/3,   0, 0, 10, head_offset_cCmMyk }}},
      { "Gray",     N_("Black"),
        {{ 1, COLOR_MODE_K,        208, 324, 0, 10, head_offset_cmyk },
         { 1, COLOR_MODE_K,        208, 324, 0, 10, head_offset_cmyk }}},
      { NULL, NULL }
    }
Definition at line 600 of file print-lexmark.c.

const lexmark_cap_t lexmark_model_capabilities[]`[static]`

| Definition at line 696 of file print-lexmark.c.

const paper_t lexmark_paper_list[]`[static]`

| Definition at line 860 of file print-lexmark.c. Referenced by get_media_type().

const lexmark_res_t_array lexmark_reslist_3200`[static]`

| Initial value:
    {

      { "300x600dpi",     N_ ("300 DPI x 600 DPI"),                  300,  600,  0,    1,    1,    0,    DPI300 },
      { "600dpi",         N_ ("600 DPI"),                            600,  600,  0,    1,    1,    0,    DPI600 },
      { "600hq",          N_ ("600 DPI high quality"),               600,  600,  1,    4,    1,    0,    DPI600 },
      { "600uni",         N_ ("600 DPI Unidirectional"),             600,  600,  0,    1,    1,    1,    DPI600 },
      { "1200dpi",        N_ ("1200 DPI"),                          1200, 1200,  1,    1,    1,    0,    DPI1200},
      { "1200hq",         N_ ("1200 DPI high quality"),             1200, 1200,  1,    1,    1,    0,    DPI300 },
      { "1200hq2",        N_ ("1200 DPI highest quality"),          1200, 1200,  1,    1,    1,    0,    DPI600 },
      { "1200uni",        N_ ("1200 DPI  Unidirectional"),          1200, 1200,  0,    1,    1,    1,    DPI1200},
      { "",                 "", 0, 0, 0, 0, 0, -1 }
    }
Definition at line 655 of file print-lexmark.c.

const lexmark_res_t_array lexmark_reslist_z52`[static]`

| Initial value:
    {

      { "300x600dpi",     N_ ("300 DPI x 600 DPI"),                  300,  600,  0,    1,    1,    0,    DPI300 },
      { "600dpi",         N_ ("600 DPI"),                            600,  600,  0,    1,    1,    0,    DPI600 },
      { "600hq",          N_ ("600 DPI high quality"),               600,  600,  1,    4,    1,    0,    DPI600 },
      { "600uni",         N_ ("600 DPI Unidirectional"),             600,  600,  0,    1,    1,    1,    DPI600 },
      { "1200dpi",        N_ ("1200 DPI"),                          1200, 1200,  1,    1,    1,    0,    DPI1200},
      { "1200hq",         N_ ("1200 DPI high quality"),             1200, 1200,  1,    1,    1,    0,    DPI300 },
      { "1200hq2",        N_ ("1200 DPI highest quality"),          1200, 1200,  1,    1,    1,    0,    DPI600 },
      { "1200uni",        N_ ("1200 DPI  Unidirectional"),          1200, 1200,  0,    1,    1,    1,    DPI1200},
      { "2400x1200dpi",   N_ ("2400 DPI x 1200 DPI"),               2400, 1200,  1,    1,    1,    0,    DPI1200},
      { "2400x1200hq",    N_ ("2400 DPI x 1200 DPI high quality"),  2400, 1200,  1,    1,    1,    0,    DPI600 },
      { "2400x1200hq2",   N_ ("2400 DPI x 1200 DPI highest quality"),2400, 1200,  1,    1,    1,    0,    DPI300},

      { "",                 "", 0, 0, 0, 0, 0, -1 }
    }
Definition at line 579 of file print-lexmark.c.

const int lr_shift_black[10] = { 9, 18, 2*18 }`[static]`

| Definition at line 266 of file print-lexmark.c. Referenced by get_lr_shift().

const int lr_shift_color[10] = { 9, 18, 2*18 }`[static]`

| Definition at line 265 of file print-lexmark.c.

int lxm3200_headpos = 0`[static]`

| Definition at line 632 of file print-lexmark.c. Referenced by lexmark_init_line().

int lxm3200_linetoeject = 0`[static]`

| Definition at line 633 of file print-lexmark.c.

stp_param_string_t media_sources[]`[static]`

| Initial value:
    {
      { "Auto",             N_("Auto Sheet Feeder") },
      { "Manual",           N_("Manual with Pause") },
      { "ManualNP",         N_("Manual without Pause") }
    }
Definition at line 1121 of file print-lexmark.c.

const char outbufHeader_3200[LXM_3200_HEADERSIZE]`[static]`

| Initial value:
    {
      0x1b, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
      0x1b, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
      0x1b, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    }
Definition at line 636 of file print-lexmark.c. Referenced by lexmark_init_line().

const unsigned char outbufHeader_z42[LXM_Z42_HEADERSIZE]`[static]`

| Initial value:
    {
      0x1B,0x2A,0x24,0x00,0x00,0x00,0x00,
      0x01,0x01,0x01,0x18,0x00,0x01,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00,0x00,
      0x00,0x00,0x00,0x00,0x00,0x00
    }
Definition at line 569 of file print-lexmark.c. Referenced by lexmark_init_line().

const unsigned char outbufHeader_z52[LXM_Z52_HEADERSIZE]`[static]`

| Initial value:
    {
      0x1B,0x2A,0x24,0x00,0x00,0xFF,0xFF,
      0x01,0x01,0x01,0x1a,0x03,0x01,
      0x03,0x60,
      0x04,0xe0,
      0x19,0x5c,
      0x0,0x0,
      0x0,0x80,
      0x0,0x0,0x0,0x0,0x1,0x2,0x0,0x0,0x0,0x0,0x0
    }
Definition at line 556 of file print-lexmark.c. Referenced by lexmark_init_line().

const int paper_type_count = sizeof(lexmark_paper_list) / sizeof(paper_t)`[static]`

| Definition at line 916 of file print-lexmark.c.

const stp_shade_t photo_dither_shades[]`[static]`

| Initial value:
    {
      { 1.0000, 1, single_dotsize },
      { 0.3333, 1, single_dotsize },
    }
Definition at line 83 of file print-lexmark.c.

stp_family_t print_lexmark_module_data`[static]`

| Initial value:
      {
        &print_lexmark_printfuncs,
        NULL
      }
Definition at line 3064 of file print-lexmark.c. Referenced by print_lexmark_module_init().

const stp_printfuncs_t print_lexmark_printfuncs`[static]`

| Initial value:
    {
      lexmark_list_parameters,
      lexmark_parameters,
      stp_default_media_size,
      lexmark_imageable_area,
      lexmark_limit,
      lexmark_print,
      lexmark_describe_resolution,
      lexmark_describe_output,
      stp_verify_printer_params,
      NULL,
      NULL
    }
Definition at line 2192 of file print-lexmark.c.

const stp_dotsize_t single_dotsize[]`[static]`

| Initial value:
    {
      { 0x1, 1.0 }
    }
Definition at line 78 of file print-lexmark.c.

const char standard_hue_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"-6\" upper-bound=\"6\">\n"
      "0.00 0.06 0.10 0.10 0.06 -.01 -.09 -.17 "
      "-.25 -.33 -.38 -.38 -.36 -.34 -.34 -.34 "
      "-.34 -.34 -.36 -.40 -.50 -.40 -.30 -.20 "
      "-.12 -.07 -.04 -.02 0.00 0.00 0.00 0.00 "
      "0.00 0.00 0.00 -.05 -.10 -.15 -.22 -.24 "
      "-.26 -.30 -.33 -.28 -.25 -.20 -.13 -.06 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 210 of file print-lexmark.c.

const char standard_lum_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"0\" upper-bound=\"4\">\n"
      "0.50 0.52 0.56 0.60 0.66 0.71 0.74 0.77 "
      "0.81 0.79 0.74 0.68 0.70 0.74 0.77 0.82 "
      "0.88 0.93 0.95 0.97 0.97 0.96 0.95 0.95 "
      "0.95 0.96 0.97 0.98 0.99 1.00 1.00 1.00 "
      "1.00 0.97 0.94 0.92 0.90 0.88 0.85 0.79 "
      "0.69 0.64 0.58 0.54 0.54 0.54 0.53 0.51 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 195 of file print-lexmark.c.

const char standard_sat_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"0\" upper-bound=\"4\">\n"
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 0.95 0.90 0.90 0.90 0.90 0.90 0.90 "
      "0.90 0.95 0.95 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 180 of file print-lexmark.c.

stp_module_t stp_module_data

| Initial value:
      {
        "lexmark",
        VERSION,
        "Lexmark family driver",
        STP_MODULE_CLASS_FAMILY,
        NULL,
        print_lexmark_module_init,
        print_lexmark_module_exit,
        (void *) &print_lexmark_module_data
      }
Definition at line 3090 of file print-lexmark.c.

stp_module_version_t stp_module_version = {0, 0}

| Definition at line 3088 of file print-lexmark.c.

const int the_parameter_count`[static]`

| Initial value:
    sizeof(the_parameters) / sizeof(const stp_parameter_t)
Definition at line 314 of file print-lexmark.c.

const stp_parameter_t the_parameters[]`[static]`

| Definition at line 268 of file print-lexmark.c.